/* ********************************************************************<pre>
 * 
 * uiDTOvNX
 * 
</pre>********************************************************************/
package order;

import java.text.SimpleDateFormat;
import java.util.Date;

import dbUtil.*;
import resource.product.*;
import resource.employee.*;
import resource.customer.*;
import _interface.*;
public class Order implements InfOrder{
	private OrderBeans orderBeans;
	private OrderDTO orderDTO;
	private OrderDAO orderDAO;
	private InfProduct product;
	private InfCustomer customer;
	private InfEmployee employee;
	
	public Order(){}
	public Order(OrderBeans orderBeans){
		this.orderBeans=orderBeans;
	}
	/** ********************************************************
	 * 󒍊mF
	 ***********************************************************/
	public int orderCheck() throws SystemErrException{
		//@\[XnIuWFNg̐
		generateInstanceFromBeans();
		
		//AIuWFNg̑݃`FbN
		String message=inspectExist();
		
		//B݌ɂ̃`FbN
		message=message+inspectStock();
		
		//C󒍋z̃`FbN
		message=message+inspectMoney();

		//D\ڂ̃Zbg
		setBeans();
		
		//E[ꏊ͂̂Ƃ̏u
		if(orderBeans.getDeliveryPlace().equals(""))
			orderBeans.setDeliveryPlace("iڋqZɓj");
		
		//FT[ubgւ̖߂
		if(!message.equals("")){
			this.orderBeans.setMessage(message);
			return -1;
		}else{
			this.orderBeans.setMessage("󒍓emFł܂");
			return 0;
		}
	}
	/** ********************************************************
	 * 󒍊m
	 ***********************************************************/
	public int orderDecide() throws SystemErrException{
		//@͓e̍ă`FbN
		if(orderCheck()<0)return -1;
		
		//A󒍔ԍ̔s
		this.orderBeans.setOrderNo(publicationNo());
		
		//BǉpDTOւBeansڂ̃Zbg
		setOrderDTO();
		
		//C󒍃R[h̒ǉ
		this.orderDAO=new OrderDAO();
		this.orderDAO.orderInsert(this.orderDTO);
		
		//DT[ubgւ̖߂
		this.orderBeans.setMessage("󒍊m肵܂B");
		return 0;
	}
	/** ********************************************************
	 * 󒍎
	 ***********************************************************/
	public int orderCancel() throws SystemErrException{
		//@󒍂̑݃`FbN
		this.orderDAO=new OrderDAO();
		this.orderDTO=this.orderDAO.orderRefer(this.orderBeans.getOrderNo());
		if(this.orderDTO.getOrderNo()==0){
			this.orderBeans.setMessage("w̎󒍔ԍ݂͑܂B");
			return -1;
		}
		//AΏۃR[h̍폜
		this.orderDAO.orderDelete(this.orderBeans.getOrderNo());
		return 0;
	}
	/** ********************************************************
	 * 󒍍XV
	 ***********************************************************/
	public int orderUpdate() throws SystemErrException{
		//@XV󒍂̑݃`FbN
		this.orderDAO=new OrderDAO();
		this.orderDTO=this.orderDAO.orderRefer(this.orderBeans.getOrderNo());
		if(this.orderDTO.getOrderNo()==0){
			this.orderBeans.setMessage("ύX悤ƂĂ󒍔ԍ݂͑܂B");
			return -1;
		}
		//AύXpDTOւBeansڂ̃Zbg
		setOrderDTO();
		
		//B󒍃R[h̍XV
		this.orderDAO.orderUpdate(this.orderDTO);
		orderRefer();
		this.orderBeans.setMessage("ύX܂B");
		return 0;
	}
	/** ********************************************************
	 * 󒍏Ɖ
	 ***********************************************************/
	public int orderRefer() throws SystemErrException{
		//@Ɖ󒍂̓Ǎ
		this.orderDAO=new OrderDAO();
		this.orderDTO=this.orderDAO.orderRefer(this.orderBeans.getOrderNo());		
		if(this.orderDTO.getOrderNo()==0){
			this.orderBeans.setMessage("w肳ꂽ󒍔ԍ݂͑܂B");
			return -1;
		}
		//A֘A郊\[XnIuWFNg̐
		generateInstanceFromDTO();
		
		//B\ẽZbg
		setBeans();
		setBeansFromDTO();
		return 0;
	}
	/** ********************************************************
	 * (֐)֘A郊\[XnIuWFNg̐
	 ***********************************************************/
	private void generateInstanceFromBeans()throws SystemErrException{
		this.product=new Product(this.orderBeans.getProductCode());
		this.customer=new Customer(this.orderBeans.getCustomerCode());
		this.employee=new Employee(this.orderBeans.getEmpCode());
	}
	private void generateInstanceFromDTO()throws SystemErrException{
		this.product=new Product(this.orderDTO.getProductCode());
		this.customer=new Customer(this.orderDTO.getCustomerCode());
		this.employee=new Employee(this.orderDTO.getEmpCode());
	}
	/** ********************************************************
	 * (֐)֘A郊\[XnIuWFNg̑݃`FbN
	 ***********************************************************/
	private String inspectExist(){
		String message="";
		if(!product.isExist())message="iR[h ";
		if(!customer.isExist())message=message + "ڋqR[h ";
		if(!employee.isExist())message=message + "S҃R[h ";
		if(message !="")message=message + "̓̓~XłB";
		return message;		
	}
	/** ********************************************************
	 * (֐)݌ɂ̃`FbN
	 ***********************************************************/
	private String inspectStock()throws SystemErrException{
		String message="";
		if(product.isExist()){
			//L݌>=󒍐ʂł邱
			int[] stock=product.stockInq(this.orderBeans.getDeliveryDate().substring(0,6));
			if((stock[0]-stock[1]-this.orderBeans.getOrderAmount())<0)
							message=message+"݌ɕsłB";
		}
		return message;
	}
	/** ********************************************************
	 * (֐)󒍋z̃`FbN
	 ***********************************************************/
	private String inspectMoney(){
		String message="";
		if(product.isExist()){
			//󒍋zelȓɂ邱
			double maxPrice=product.getNormalPrice()*
							this.orderBeans.getOrderAmount()*UpperLimit;
			double minPrice=product.getNormalPrice()*
							this.orderBeans.getOrderAmount()*LowerLimit;
			if(!(this.orderBeans.getOrderMoney()<=maxPrice && 
							this.orderBeans.getOrderMoney()>=minPrice)){
				message=message+"󒍋zsłB";
			}
		}
		return message;
	}
	/** ********************************************************
	 * (֐)Beansւ̕\ڂ̃Zbg
	 ***********************************************************/
	private void setBeans(){
		if(customer.isExist()){
			this.orderBeans.setCustomerCode(this.customer.getCustomerCode());
			this.orderBeans.setCustomerName(this.customer.getCustomerName());
			this.orderBeans.setCustomerAddress(this.customer.getCustomerAddress());
			this.orderBeans.setCustomerTel(this.customer.getCustomerTel());
		}
		if(product.isExist()){
			this.orderBeans.setProductCode(this.product.getProductCode());
			this.orderBeans.setProductName(this.product.getProductName());
			this.orderBeans.setNormalPrice(this.product.getNormalPrice());
		}
		if(employee.isExist()){
			this.orderBeans.setEmpCode(this.employee.getEmpCode());
			this.orderBeans.setEmpName(this.employee.getEmpName());
		}
	}
	private void setBeansFromDTO(){
		this.orderBeans.setOrderDate(this.orderDTO.getOrderDate());
		this.orderBeans.setOrderAmount(this.orderDTO.getOrderAmount());
		this.orderBeans.setOrderMoney(this.orderDTO.getOrderMoney());
		this.orderBeans.setDeliveryDate(this.orderDTO.getDeliveryDate());
		this.orderBeans.setDeliveryPlace(this.orderDTO.getDeliveryPlace());
	}
	/** ********************************************************
	 * (֐)󒍃R[ho͗pDTOւBeansڂ̃Zbg
	 ***********************************************************/
	private void setOrderDTO(){
		this.orderDTO=new OrderDTO();
		this.orderDTO.setOrderNo(this.orderBeans.getOrderNo());
		this.orderDTO.setOrderDate(this.orderBeans.getOrderDate());
		this.orderDTO.setCustomerCode(this.orderBeans.getCustomerCode());
		this.orderDTO.setProductCode(this.orderBeans.getProductCode());
		this.orderDTO.setOrderAmount(this.orderBeans.getOrderAmount());
		this.orderDTO.setOrderMoney(this.orderBeans.getOrderMoney());
		this.orderDTO.setDeliveryDate(this.orderBeans.getDeliveryDate());
		this.orderDTO.setDeliveryPlace(this.orderBeans.getDeliveryPlace());
		this.orderDTO.setEmpCode(this.orderBeans.getEmpCode());		
	}
	/** ********************************************************
	 * (֐)󒍔ԍ̔s
	 ***********************************************************/
	private int publicationNo()throws SystemErrException{
		SimpleDateFormat sdf=new SimpleDateFormat("yyyy");
		int retOrderNo=Integer.parseInt(sdf.format(new Date()))*10000+1;
		//@Ɖ󒍂̓Ǎ
		this.orderDAO=new OrderDAO();
		int maxOrderNo=orderDAO.orderMaxNo();
		if(retOrderNo <= maxOrderNo)retOrderNo=maxOrderNo+1;
		return retOrderNo;
	}
}
